\documentclass[titlepage,a4paper]{article}

\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}

% Selection de la langue
%--------------------------------------------------------------------------

\usepackage[english, shorthands=off]{babel}
\selectlanguage{english}

% Titre, auteur, matière et date
%--------------------------------------------------------------------------

\newcommand{\titre}{State of the art - OP-TEE OS} 
\newcommand{\Universite}{Bordeaux I}
\newcommand{\auteur}{MARIE Nathanaël}
\newcommand{\tuteur}{Tuteur : BELOUARGA Mohamed}
%\newcommand{\autor2}{Autor2}
% etc
\newcommand{\TnS}{T\&S}
\newcommand{\ville}{Bordeaux}
\newcommand{\ajd}{\today}

% Paquete para generar texto de relleno. Se puede eliminar
%--------------------------------------------------------------------------

\usepackage{lipsum}
\usepackage{csquotes}
\usepackage{svg}
\usepackage[
    %backend=biber, 
    natbib=true,
    style=numeric,
    sorting=none
]{biblatex}
\addbibresource{ref.bib} %Import the bibliography file
\usepackage{parskip}

\usepackage{enumitem}

\newlist{notes}{enumerate}{1}
\setlist[notes]{label=\textbf{Note:} ,leftmargin=*}

% Dimensiones de página
%--------------------------------------------------------------------------

\usepackage[a4paper,includeheadfoot,margin=2.54cm]{geometry}

% Paquetes de la AMS
%--------------------------------------------------------------------------

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}


% Paquetes de símbolos usuales y de formato de ecuaciones
%--------------------------------------------------------------------------

\usepackage{textcomp}
\usepackage{mathtools}
\usepackage{commath}

% Teoremas
%--------------------------------------------------------------------------

\newtheorem{thm}{Teorema}
\newtheorem*{thm*}{Teorema}
\newtheorem{cor}[thm]{Corolario}
\newtheorem{lem}[thm]{Lema}
\newtheorem{prop}[thm]{Proposición}
\theoremstyle{definition}
\newtheorem{defn}[thm]{Definición}
\newtheorem*{defn*}{Definición}
\theoremstyle{remark}
\newtheorem{rem}[thm]{Observación}



% Atajos.
% Se pueden definir comandos nuevos para acortar cosas que se usan
% frecuentemente. Como ejemplo, aquí se definen las letras dobles usadas para
% los conjuntos de los números naturales, enteros, racionales, reales
% y complejos.
%--------------------------------------------------------------------------

\def\NN{\mathbb{N}}
\def\ZZ{\mathbb{Z}}
\def\QQ{\mathbb{Q}}
\def\RR{\mathbb{R}}
\def\CC{\mathbb{C}}

% Paquetes para la inserción de imágenes y figuras
%--------------------------------------------------------------------------

\usepackage{float}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{caption}

% Formato de los índices
%--------------------------------------------------------------------------
\usepackage{hyperref} % referencias interactivas
\usepackage{tocloft} % paquete de diseño tipográfico

\renewcommand{\cftsecfont}{\normalfont} % evita que los títulos del índice aparezcan en negrita
\renewcommand{\cftsecleader}{\cftdotfill{\cftdotsep}} % crea una línea de puntos entre el índice y el número

% Paquetes y configuración para la inserción de código
% Por defecto los colores emulan los del editor de MATLAB
%--------------------------------------------------------------------------

\usepackage{color}
\usepackage{listings}

\definecolor{mGreen}{rgb}{0,0.6,0}
\definecolor{mGray}{rgb}{0.5,0.5,0.5}
\definecolor{mPurple}{rgb}{0.58,0,0.82}
\definecolor{backgroundColour}{rgb}{0.95,0.95,0.92}

\lstdefinestyle{CStyle}{
    backgroundcolor=\color{backgroundColour},   
    commentstyle=\color{mGreen},
    keywordstyle=\color{magenta},
	emph={TEEC_Result,TEEC_Context,TEEC_Session,TEEC_Operation,TEEC_UUID, uint32_t, TEE_Result,
	TEE_Param  },
    emphstyle=\color{magenta},
    numberstyle=\tiny\color{mGray},
    stringstyle=\color{mPurple},
    basicstyle=\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2,
    language=C
}


% Encabezado y pie de página (no es necesaria modificación)
%--------------------------------------------------------------------------

\usepackage{fancyhdr} % Paquete de estilo 
\setlength{\headheight}{12.2pt}
\pagestyle{fancy} % selección del estilo
\fancyhf{}

\renewcommand{\headrulewidth}{0.5pt} % Grosor de las líneas
\renewcommand{\footrulewidth}{0.5pt}

\lhead{\scshape \TnS} 
\rhead{\titre}
\lfoot{\auteur}
\rfoot{\thepage}

% Inicio del documento
%--------------------------------------------------------------------------

\begin{document}
% Si no se desea portada, sustitúyanse las siguientes líneas por:
%\title{\titulo}
%\author{\autor}
%\date{\fecha}

% Portada
%----------------------------------------------------------------------

\begin{titlepage}

	\centering

	\includegraphics[width=0.6\textwidth]{Images/Logo_t&s.png}\par\vspace{0.5cm}

	{\scshape\LARGE Technology \& Strategy}

	\vspace{1cm}

	\vspace{1.5cm}

	{\huge\bfseries \titre\par}	% puede ser necesario modificar si se desea más de una línea

	\vspace{3cm}

	{\Large\itshape \auteur} %\par\vspace{0.1cm} \autor2\par\vspace{0.1cm} \autor3}

	\vfill

	\ville\par

	\today
\end{titlepage}

% Dejamos la siguiente página en blanco y sin numerar:

%\clearpage\thispagestyle{empty}\mbox{}\setcounter{page}{0}\clearpage

% Abstract (borrar el "%" si se requiere)
%----------------------------------------------------------------------
%\abstract{}

% Sommaire
%----------------------------------------------------------------------
\tableofcontents
\listoffigures
\newpage{} % Enlever si pas de saut de page après le sommaire

\section*{Intro}
OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone technology. \cite{OP-TEE-rtd}
\\
This state of the art will therefore enable us to define the various terms and technologies involved in OP-TEE.

\section[TEE - Trusted Execution Environment]{TEE - Trusted Execution Environment\cite{7345265}}

\subsection{Definition}
A \textbf{Trusted Execution Environment} (TEE) is a tamper-proof processing environment that runs on a separation kernel (a security kernel that allows different systems requiring different levels of security to coexist). It guarantees the authenticity of executed code, the integrity of execution states (e.g. sensitive CPU registers, memories and I/O), and the confidentiality of its code, data and execution states stored in persistent memory. In addition, it must be able to provide remote certification that proves its reliability to third parties. The content of a TEE is not static; it can be securely updated.

\subsection{Concept of trust in a TEE}
The trust of a TEE is hybrid, it is both static (based on a complete evaluation against a specific set of security requirements) and semi-dynamic (the TEE is not expected to change its trust level during execution, as it is protected by the separation kernel).

\subsection{Main components of a TEE}
\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/TEE_Building_blocks.png}
	\caption{TEE Building Blocks (Image Credit : \cite{7345265})}
	\label{fig:blocks}
\end{figure}

By definition, an TEE is made up of a number of basic components, as illustrated in the figure. \ref{fig:blocks} :
\begin{itemize}
	\item \textbf{Secure Boot} : ensures that only code with a certain property can be loaded. If a modification is detected, the boot process is interrupted.
	\item \textbf{Secure Scheduling} : ensures balanced and effective coordination between the TEE and the rest of the system. It must ensure that the tasks performed in the TEE do not affect the responsiveness of the main OS (operating system).
	\item \textbf{Inter-Environment Communication} : define an interface authorizing the TEE to communicate with the rest of the system.
	\item \textbf{Secure Storage} : this is storage where the confidentiality, integrity and freshness of the data stored is guaranteed, and where only authorized entities can access this data.
	\item \textbf{Trusted I/O} : protects the authenticity, and optionally the confidentiality, of communications between the TEE and peripherals (e.g. keyboard, sensors). As a result, input and output data are protected against capture and falsification by malicious applications.
\end{itemize}

\section[TrustZone]{TrustZone\cite{TrustZone}}
\textbf{TrustZone} is a technology used by \textbf{ARM processors} to isolate security-critical components in a system, by hardware separating a so-called non-secure operating system (or \textbf{Rich OS}) from a much smaller, secure operating system (\textbf{Trusted OS}). More specifically, it is designed to provide a hardware-reinforced logical separation between the security components and the rest of the \textbf{SoC} (System-on-Chip) infrastructure. This makes it possible to combat both hack attacks (where the hacker is only capable of executing a software attack) and shack attacks (a low-budget hardware attack, using equipment that could be bought on the high street from a store such as Radio Shack).

\subsection{TrustZone hardware architecture}
TrustZone's hardware architecture aims to provide a security framework that enables a device to counter most of the specific threats it will face. Rather than providing a single, fixed security solution, TrustZone technology provides the infrastructure foundation that allows an IC designer to choose from a range of components that can perform specific functions in the security environment. System security is achieved by partitioning all SoC hardware and software resources so that they exist in one of two worlds: the secure world for the security subsystem and the non-secure world for everything else.

\begin{notes}
	\item The use of the word world is used to describe not just the Execution state, but also all memory and peripherals that are accessible in that state.
\end{notes}

This architecture has three main components:
\begin{itemize}
	\item The hardware logic in the TrustZone-compatible \textbf{AMBA3 AXI} bus ensures that no resources in the secure world can be accessed by components in the non-secure world.
	\item Extensions that have been implemented in some ARM processor cores. These additions enable a single physical processor core to safely and efficiently execute code from both the \textbf{non-secure
		      world} and the \textbf{secure world} in a time-sliced fashion.
	\item A security-aware debugging infrastructure that can control access to debugging in the secure world, without compromising the visibility of debugging in the non-secure world.
\end{itemize}

\subsubsection{AXI Protocol}
What is a bus? A bus is a sub-system used to connect the components of a computer and transfer data between them. \cite{Bus}. There are several types, such as :
\begin{itemize}
	\item \textbf{System Bus} : A parallel bus that simultaneously transfers data in 8-, 16-, or 32-bit channels and is the primary pathway between the CPU and memory.
	\item \textbf{External Bus} : Connects peripheral devices to the motherboard, such as scanners or disk drives.
\end{itemize}

\textbf{AXI} (Advanced eXtensible Interface) is an on-chip bus communication protocol that is part of the \textbf{AMBA} (Advanced Microcontroller Bus Architecture) specification.\cite{AXI-ARM}

In order to guarantee effective separation of the hardware resources of the two worlds, the \textbf{AXI System Bus protocol} defines a control signal called \textbf{NS bits} (Non-Secure bits) for each write and read channel. AXI provides access authorization signals, \textbf{AWPROT} and \textbf{ARPROT}, which can protect against illegal transactions in the system. \textbf{AWPROT[1]} defines whether write transaction is secure (0: low signal) or not (1: high signal). The same applies to \textbf{ARPROT[1]}, which defines the security level of a read transaction. All Bus managers set these signals when they perform a new transaction, and the decoding logic of the Bus or subordinate must interpret them. The NS bits of all non-secure managers must be set to High in hardware, which prevents them from accessing secure subordinates.

If a non-secure manager attempts to access a secure subordinate, the implementation defines whether the operation fails silently or whether an error is raised by the bus or the subordinate (\textbf{SLVERR}, slave error or a \textbf{DECERR}, decode error).

The TrustZone architecture also makes it possible to secure peripherals (e.g. interrupt controllers, timers, user I/O devices). Each \textbf{APB} (Advanced Peripheral Bus) is connected to the system bus via the \textbf{AXI-to-APB} gateway. The gateway must reject transactions with inappropriate security parameters and must not transmit these requests to the peripherals.

\subsubsection{Processor architecture}
For processors implementing the security architectural extension, each of the processor's physical cores offers two virtual cores, one considered non-secure and one secure, as well as a mechanism for performing context switches in a robust manner called Monitor Mode. The NS bit value sent to the system bus is indirectly derived from the identity of the virtual core performing the instruction or memory access. This ensured that the non-secure virtual processor could only access the resources of the non-secure system, while the secure virtual processor could access all the resources. \ref{fig:NS_S}.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/NS_and_S_world.png}
	\caption{Secure and non-secure world (Image Credit : ARM \cite{TrusteZoneAArch64})}
	\label{fig:NS_S}
\end{figure}

The two virtual processors are executed in a fractioned manner over time, passing through a new core mode called \textbf{Monitor Mode} when the virtual processor is changed during execution. It is therefore up to Monitor Mode to save the state of the processor when the context changes. This entry into Monitor Mode can be triggered by software executing a dedicated instruction (the \textbf{SMC} or Secure Monitor Call instruction), or by a hardware exception. Except when the processor is in Monitor Mode, the world in which the processor is executing is indicated by the NS-bit in the \textbf{SCR} (Secure Configuration Register) in \textbf{CP15} \cite{Arm2021Dec}. In Monitor Mode, the processor always runs in the secure world, whatever the value of the NS-bit in the SCR.

\begin{notes}
	\item In the \textbf{AArch64} execution state, there are three privileged modes and one user mode. These are referred to as exception levels. The higher the exception level, the more privilege the code has. Typically, the system uses the exception levels as follows:
	\begin{itemize}
		\item \textbf{EL0} : User application
		\item \textbf{EL1} : OS kernel and other privileged code
		\item \textbf{EL2} : Hypervisor (support for virtual machine)
		\item \textbf{EL3} : Secure monitor (manage security contexts)
	\end{itemize}
	The major difference between EL0 and the higher levels is that code executing in EL0 cannot access system registers. EL1 can access most system registers, EL2 has additional privileges, and EL3 has all privileges. The only way that the processor can change from one exception level to a higher level is when an exception occurs. The only way that the processor can move to a lower exception level is by executing an exception return instruction \cite{EL0123}

	So EL3 is meant to manage the security state, and it is where the processor is when it is in Monitor Mode.
\end{notes}


In a TrustZone processor, the hardware provides two \textbf{virtual MMUs} \cite{MMU}, one for each virtual processor. This allows each world to have a local set of \textbf{virtual-to-physical address translation tables} (with an NS field for ARMv6 and ARMv7). \textbf{TLBs} (Translation Lookaside Buffers \cite{TLB}) can now also have an \textbf{NSTID} field with the identity of the world that made the entry, as well as caches with an NS field (see fig.\ref{fig:TLB}). This allows non-secure and secure entries to co-exist in caches, speeding up context switching as there is no need to flush entries from TLBs or caches.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/TLB.png}
	\caption{Level one memory system for a theoretical ARM core (Image Credit : ARM \cite{TrustZone})}
	\label{fig:TLB}
\end{figure}

A TrustZone-enabled processor implements three sets of Exception Vector Tables. One table for each of the worlds (virtual processor): the non-secure world, the secure world and one for Monitor Mode. ARM recommends using IRQ as the interrupt source in the non-secure world and FIQ in the secure world.

In a multiprocessor architecture, each processor has two worlds: the non-secure world and the secure world, each with independent control over the configuration of its MMU.

\subsection{Debugging architecture}
The debugging solutions provided by ARM are divided into two parts: processor debugging modules and system debugging modules.

\subsubsection{Processor debugging}
Signals have been set up to activate the various debugging, tracing and profiling functions. These include separate signals to control the use of functions in the secure and non-secure worlds.
There are two relevant signals:
\begin{itemize}
	\item \textbf{DBGEN} : Controls access to the debugger in the non-secure world, used when debugging applications in the non-secure world.
	\item \textbf{SPIDEN} : Controls access to the debugger in the secure world. It is crucial for debugging and maintaining secure components in TrustZone, while maintaining a high level of security.
\end{itemize}

\subsubsection{System debugging}
The ARM system debugging solution is \textbf{ARM CoreSight} on-chip debugging and tracing technology. It provides a debugging and tracing solution for the entire SoC. Designed not to use the standard per-device protection mechanisms provided by an AXI-to-APB gateway, CoreSight components must be accessible to non-secure memory transactions. As an alternative, CoreSight components use signals that play a similar role to those described for processor debugging (SPIDEN, SPNIDEN, DBGEN).

If external debugging hardware or non-secure world software attempts to establish a system breakpoint on a secure address when SPIDEN is disabled, the CoreSight hardware will fail to create a breakpoint.

\subsection{Software architecture}
Since the security extension of the ARM architecture is open to everyone, any developer can create a completely customized secure world.

Relevant designs to mention are those that closely resemble the software stacks that would be seen in a SoC with two separate physical processors in configurations such as \textbf{AMP} (Asymmetric Multi-Processing) or \textbf{SMP} (Symmetric Multi-Processing) :
\begin{itemize}
	\item The most extreme would be an 'AMP' design. The software running on one of the two virtual processors is an autonomous operating system, and each world uses hardware interrupts to preempt the running world and acquire processor time.
	\item Alternatively, a slightly more integrated design would be an 'SMP' design, where a communication protocol is used to associate tasks in the secure world with the thread in the non-secure world that requested them. This would allow some form of real-time response for media applications, for example.
\end{itemize}

In a 'SMP' design, it is unlikely that a user-space application will be directly aware of the existence of TrustZone. Instead, it will use a \textbf{high-level API} provided by a user-space library. This library manages communication with the trusted service in the secure world. This communication is managed using message queues or mailboxes which are placed in non-secure memory so that both worlds can access them (see fig.\ref{fig:Pile}).
The service library places one or more requests in the mailbox, then calls a driver in kernel space. The driver is responsible for low-level interactions with the TEE, which may include allocating memory for message queues and registering them with the TEE.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.9\textwidth]{Images/SoftStack.png}
	\caption{Software stack for a system using TrustZone (Image Credit : ARM \cite{TrusteZoneAArch64})}
	\label{fig:Pile}
\end{figure}

The driver calls the secure world, usually using an SMC. Control is passed through the EL3 secure monitor to the trusted kernel in the TEE. The kernel invokes the requested service, which can then read the request from the queue.

\subsubsection{System booting}
A TrustZone-enabled processor boots into the secure world when it is powered up. This allows all security-sensitive checks to be run before non-secure world software has a chance to change any aspect of the system.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.7\textwidth]{Images/amorcage.png}
	\caption{TrustZone system boot sequence (Image Credit : ARM \cite{TrustZone})}
	\label{fig:Boot}
\end{figure}

\newpage
We have just seen how TrustZone technology works and, as explained, it represents the basis for establishing a secure system. TrustZone is primarily concerned with hardware-level security, so we need software that can work with TrustZone to provide a comprehensive security solution.

\section{Open-source Portable TEE (OP-TEE)}
\textbf{OP-TEE }is an open source project, which contains a full implementation to make up a complete Trusted Execution Environment using the ARM TrustZone technology \cite{OPTEEDEF}. OP-TEE meets the \textbf{GlobalPlatform TEE System Architecture specification} \cite{GlobalPlatform}.

OP-TEE has several components (see fig.\ref{fig:OPTEE-ARCHI}):
\begin{itemize}
	\item \textbf{OP-TEE Trusted OS} that executes in secure privileged (kernel) mode at EL1
	\item A set of \textbf{secure user space libraries} designed for Trusted Applications needs and upon the \textbf{GlobalPlatform TEE internal APIs} specifications.
	\item A Linux \textbf{kernel OP-TEE framework and driver} (merged to the official tree in v4.12).
	\item A Linux \textbf{user space library} (op-tee\_client) designed upon the \textbf{GlobalPlatform TEE Client API} specifications.
	\item A Linux \textbf{user space supplicant daemon} (tee-supplicant) responsible for remote services expected by the TEE OS.
	\item A \textbf{test suite} (xtest), for doing regression testing and testing the consistency of the API implementations.
	\item An example git containing a couple of simple hosts- and TA-examples.
	\item And some build scripts, debugging tools to ease its integration and the development of Trusted Applications and secure services.
\end{itemize}

\begin{figure}[H]
	\centering
	\includegraphics[width=1\textwidth]{Images/OP_TEE_Soft_Archi.png}
	\caption{OP-TEE software Architecture (Image Credit: \cite{Demyst})}
	\label{fig:OPTEE-ARCHI}
\end{figure}

OP-TEE is designed primarily to rely on the Arm TrustZone technology as the underlying hardware isolation mechanism. However, it has been structured to be compatible with any isolation technology suitable for the TEE concept and goals, such as running as a virtual machine or on a dedicated CPU.

As an open source project, we can find the source code in this repository : \cite{OPTEEGIT}. The documentation is also available here : \cite{OP-TEE-rtd}

\subsection{Trusted Applications (TAs) and Client Applications (CAs)}
OP-TEE makes use of \textbf{Trusted Applications} as a key component. These applications contain security-critical functionality and are executed within the secure world.
In most of the cases, TAs take the form of command/service-oriented applications. When a trusted application receives a command from a client application, it parses the messages associated with the command, performs any necessary processing, and then sends a response back to the client. To help ensure security, we may perform cryptographic operations in the secure world, require secure key storage, or just require secure data storage in general. TAs can also apply algorithms that are considered intellectual property and must be kept confidential.

On the other hand, A Client typically runs in the \textbf{Regular Execution Environment} (REE) and communicates with a Trusted Application using the TEE Client API. It is then called a “Client Application”. It is also possible for a Trusted Application to act as a client of another Trusted Application, using the \textbf{Internal Client API}.


\subsection{Communications between the secure world and non-secure world}
The non-secure world uses the \textbf{TEE Client API} to communicate with the secure world. In fact, this API is a low-level communication interface designed to enable a Client Application running in the non-secure world to access and exchange data with a Trusted Application running inside the secure world.
This API provides high-level functions that facilitate the development of client applications.

\subsubsection{TEE Client API specification}
This section summarizes the TEE Client API specification v1.0, which is available here: \cite{Client_API_Spec}.

The TEE Client API concentrates on the interface to enable efficient communications between a Client Application and a Trusted Application running inside the TEE. Higher level standards and protocol layers may be built on top of the foundation provided by the TEE Client API.
\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/OPTEE_Client_Architecture.png}
	\caption{TEE Client API System architecture (Image Credit: GlobalPlatform \cite{Client_API_Spec})}
	\label{fig:ClientAPI-ARCHI}
\end{figure}

This API is based on the following design principles :
\begin{itemize}
	\item \textbf{C language} : C is the common denominator for practically all the application frameworks and operating systems hosting Client Applications (we will use a Linux distribution in our case as Rich OS)
	\item \textbf{Blocking functions} : Most Client Application developers are familiar with synchronous functions which block
	      waiting for the underlying task to complete before returning to the calling code. Since multi-threading is assumed to be available on all target platforms, it will be possible to cancel blocking API functions.
	\item \textbf{Client-side memory allocations} : Where possible the design of the TEE Client API has placed the responsibility for memory allocation on the calling Client Application code. This gives the Client developer choice of memory allocation locations, enabling simple optimizations such as stack-based allocation or enhanced flexibility using placements in static global memory or thread-local storage.
	\item \textbf{Aim for zero-copy data transfer} : The features of the TEE Client API are chosen to maximize the possibility of zero-copy data transfer between the Client Application and the Trusted Application.
	\item \textbf{Support memory sharing by pointers} : The caller will often provide memory buffers for input or output data
	      using simple C pointers.  The TEE Client API allow efficient sharing of this type of memory.
	\item \textbf{Specify only communication mechanisms} : This API focuses on defining the underlying communications channel. It does not define the format of the messages which pass over the channel, or the protocols used by specific TAs.
\end{itemize}

\subsubsection*{Getting started with the API :}
In a non-secure world, communicating with a trusted application (TA) is relatively simple for a client application (CA).
The CA must open a \textbf{Context} that abstracts the logical connection between itself and the TEE. And within the scope of this particular \textbf{TEE Context}, the CA needs to open a \textbf{Session} that abstracts the logical connection between itself to a specific TA using the Universally \textbf{Unique Identifier} (UUID) of the TA (See figure : \ref{fig:ClientAPI-Concept}). With the aid of a \textbf{Command}, which serves as the unit of communication between a CA and a TA within a Session, the CA can identify the function in the TA that it wishes to execute by passing a numeric identifier. Additionally, the CA may provide an operation payload in accordance with the protocol that the TA exposes for that function. The Command invocation blocks the CA thread, waiting for an answer from the TA.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/OP_TEE_Client_API_Comm_Archi.png}
	\caption{TEE Client API Concepts (Image Credit: \cite{Demyst})}
	\label{fig:ClientAPI-Concept}
\end{figure}

An operation to open a Session or to invoke a generic Command can carry an optional payload, the definition of which is passed inside a set of \textbf{Operation Parameters} stored in the operation structure. In this version of the specification up to 4 Parameters can be specified for each operation.

Each Parameter is either a \textbf{Memory Reference} or a \textbf{Value Parameter} and is associated with a direction: it can be \textbf{input}, \textbf{output}, or \textbf{both input and output}. For Memory Reference Parameters, the specified direction of data flow determines when the underlying memory buffers need to be synchronized with the TA. This is because output means that the buffer is transferring data from the TA to the CA and input, from the CA to the TA.

Memory Reference Parameters are used to exchange data through shared memory buffers. Value Parameters carry a small amount of data in the form of two 32-bit integers without the burden of sharing or synchronizing memory.
A Memory Reference is a range of bytes which is actually shared for a particular operation. It can specify:
\begin{itemize}
	\item A whole \textbf{Shared Memory block}.
	\item A range of bytes within a Shared Memory block.
	\item Or a pointer to a buffer of memory owned by the CA, in which case this buffer is temporarily registered for the duration of the operation.
\end{itemize}


The API allows Memory References to overlap. The Client is responsible for ensuring that the overlapping regions are consistent and meet any timing requirements when used by multiple actors; specifying an input buffer to one Trusted Application which is concurrently used as an output for another will produce undefined results, for example.

\begin{notes}
	\item \textbf{Shared Memory block} is a region of memory allocated in the context of the CA memory space that can be used to transfer data between that CA and a TA. A Shared Memory block can either be existing CA memory which is subsequently registered with the TEE Client API, or memory which is allocated on behalf of the CA using the TEE Client API (see fig.\ref{fig:Shared_Mem}).
	\begin{figure}[H]
		\centering
		\includegraphics[width=0.8\textwidth]{Images/Shared_memory_lifetime.png}
		\caption{Shared Memory Buffer Lifetime (Image Credit: GlobalPlatform \cite{Client_API_Spec})}
		\label{fig:Shared_Mem}
	\end{figure}
\end{notes}

\newpage
\subsubsection*{Hello World example}
This is the CA code for the hello world in the repository optee\_examples by Linaro available here : \cite{ClientAPI_example}
This code shows the mechanisms explained above. Other, more complex examples (involving the use of shared buffers, among other things) can be found in the GitHub repository.
\begin{lstlisting}[style=CStyle, title=optee\_examples/hello\_world/host/main.c]
#include <err.h>
#include <stdio.h>
#include <string.h>

/* OP-TEE TEE client API (built by optee_client) */
#include <tee_client_api.h>

/* For the UUID (found in the TA's h-file(s)) */
#include <hello_world_ta.h>

int main(void)
{
	TEEC_Result res;
	TEEC_Context ctx;
	TEEC_Session sess;
	TEEC_Operation op;
	TEEC_UUID uuid = TA_HELLO_WORLD_UUID;
	uint32_t err_origin;

	/* Initialize a context connecting us to the TEE */
	res = TEEC_InitializeContext(NULL, &ctx);
	if (res != TEEC_SUCCESS)
		errx(1, "TEEC_InitializeContext failed with code 0x%x", res);

	/*
	 * Open a session to the "hello world" TA, the TA will print "hello
	 * world!" in the log when the session is created.
	 */
	res = TEEC_OpenSession(&ctx, &sess, &uuid,
			       TEEC_LOGIN_PUBLIC, NULL, NULL, &err_origin);
	if (res != TEEC_SUCCESS)
		errx(1, "TEEC_Opensession failed with code 0x%x origin 0x%x",
			res, err_origin);

	/*
	 * Execute a function in the TA by invoking it, in this case
	 * we're incrementing a number.
	 *
	 * The value of command ID part and how the parameters are
	 * interpreted is part of the interface provided by the TA.
	 */

	/* Clear the TEEC_Operation struct */
	memset(&op, 0, sizeof(op));

	/*
	 * Prepare the argument. Pass a value in the first parameter,
	 * the remaining three parameters are unused.
	 */
	op.paramTypes = TEEC_PARAM_TYPES(TEEC_VALUE_INOUT, TEEC_NONE,
					 TEEC_NONE, TEEC_NONE);
	op.params[0].value.a = 42;

	/*
	 * TA_HELLO_WORLD_CMD_INC_VALUE is the actual function in the TA to be
	 * called.
	 */
	printf("Invoking TA to increment %d\n", op.params[0].value.a);
	res = TEEC_InvokeCommand(&sess, TA_HELLO_WORLD_CMD_INC_VALUE, &op,
				 &err_origin);
	if (res != TEEC_SUCCESS)
		errx(1, "TEEC_InvokeCommand failed with code 0x%x origin 0x%x",
			res, err_origin);
	printf("TA incremented value to %d\n", op.params[0].value.a);

	/*
	 * We're done with the TA, close the session and
	 * destroy the context.
	 *
	 * The TA will print "Goodbye!" in the log when the
	 * session is closed.
	 */

	TEEC_CloseSession(&sess);

	TEEC_FinalizeContext(&ctx);

	return 0;
}
\end{lstlisting}

\subsubsection{TEE internal Core API specification}
This section provides a brief summary of the \textbf{TEE Internal Core API Specification}, which can be found at the following reference : \cite{Internal_core_API}.

In the non-secure world, TAs operate and also communicate with the non-secure world and with each other through a set of APIs known as the \textbf{TEE Internals Core APIs}. These APIs provide building blocks to TAs by offering them a set of core services.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/Secure_world_interaction.png}
	\caption{Trusted Application Interactions with the Trusted OS (Image Credit: GlobalPlatform \cite{Internal_core_API})}
	\label{fig:TA_interaction}
\end{figure}


The TEE Internal Core APIs utilised by OP-TEE are categorised into five principal groups, which will be the subject of our discussion shortly :
\begin{itemize}
	\item \textbf{Trusted Core Framework API} : defining OS-like APIs and infrastructure
	\item \textbf{Trusted Storage API} for Data and Keys.
	\item \textbf{Cryptographic Operations API} :  enables several cryptographic capabilities.
	\item \textbf{Time API} : to access three sources of time.
	\item \textbf{TEE Arithmetical API} : low-level API that complements the Cryptographic Operations API, provides arithmetical functions to work on big numbers and prime field elements.
\end{itemize}



\subsubsection*{Trusted Core Framework API}
This specification defines an API that provides OS functionality – integration, scheduling, communication, memory management, and system information retrieval interfaces – and channels communications from Client Applications or other Trusted Applications to the Trusted Application.

Each Trusted Application exposes an interface (the \textbf{TA interface}) composed of a set of entry point functions that the Trusted Core Framework implementation calls to inform the TA about life cycle changes and to relay communication between Clients and the TA (like to create the instance, notify the instance that a new client is connecting, notify the instance when the client invokes a command, etc.).

The implementation of the functions described below must be provided by each TA.

\begin{lstlisting}[style=CStyle, title=TA Mandatory Entry Points]
	/* This is the Trusted Application constructor. It is called once and
	only once in the lifetime of the Trusted Application instance. If
	this function fails, the instance is not created.*/
	TEE_Result TA_CreateEntryPoint(void)
	{
		/* Allocate some resources, init something, ... */
		...

		/* Return with a status */
		return TEE_SUCCESS;
	}

	/* This is the Trusted Application destructor. The Trusted Core
	Framework calls this function just before the Trusted Application
	instance is terminated.*/
	void TA_DestroyEntryPoint(void)
	{
		/* Release resources if required before TA destruction */
		...
	}

	/* This function is called whenever a client attempts to connect to
	the Trusted Application instance to open a new session.*/
	TEE_Result TA_OpenSessionEntryPoint(uint32_t ptype,
										TEE_Param param[4],
										void **session_id_ptr)
	{
		/* Check client identity, and alloc/init some session resources if any */
		...

		/* Return with a status */
		return TEE_SUCCESS;
	}

	/* This function is called when the client closes a session and
	disconnects from the Trusted Application instance.*/
	void TA_CloseSessionEntryPoint(void *sess_ptr)
	{
		/* check client and handle session resource release, if any */
		...
	}

	/* This function is called whenever a client invokes a Trusted
	Application command.*/
	TEE_Result TA_InvokeCommandEntryPoint(void *session_id,
											uint32_t command_id,
											uint32_t parameters_type,
											TEE_Param parameters[4])
	{
		/* Decode the command and process execution of the target service */
		...

		/* Return with a status */
		return TEE_SUCCESS;
	}
\end{lstlisting}

A visual representation of the relationship between CAs and TAs can be observed in Figure \ref{fig:OP_TEE_Comm}
\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/OP_TEE_Communicatio.png}
	\caption{Communication process between CAs and TAs (Image Credit: \cite{Demyst})}
	\label{fig:OP_TEE_Comm}
\end{figure}

In contrast, the \textbf{Internal Client API} enables a TA to act as a client to another TA. Its functionality is analogous to that of the \textbf{TEE Client API}.

\begin{notes}
	\item All entry point calls within a given Trusted Application instance are called in sequence, i.e. no more than one entry point is executed at any point in time. If there is more than one entry point call to complete at any point in time, all but one call will be queued by the Framework. It is not possible to execute multiple concurrent commands within a session. The TEE guarantees that a pending command has completed before a new command is executed.
\end{notes}

\subsubsection*{Trusted Storage API for Data and Keys}
Each TA has access to a set of \textbf{Trusted Storage Spaces}, identified by 32-bit Storage Identifiers.
This specification defines different Trusted Storage Spaces for each TA, which are its own private storage spaces.
It mandates that it should be possible to store general-purpose data and key material that guarantees confidentiality and integrity of the data stored and the atomicity of the operations that modifies the storage (atomicity here means that either the entire operation completes successfully or no write is done).

A Trusted Storage Space contains \textbf{Persistent Objects}. Each persistent object is identified by an \textbf{Object Identifier}. A persistent object can be a Cryptographic Key Object, a Cryptographic Key-Pair Object, or a Data Object. Each persistent object has a type, which precisely defines the content of the object. For example, there are object types for AES keys, RSA key-pairs, data objects, etc.

A TA can also allocate \textbf{Transient Objects}. Compared to persistent objects Transient objects are held in memory and are automatically wiped and reclaimed when they are closed or when the TA instance is destroyed.

\subsubsection*{Cryptographic Operations API}
This API provides cryptographic facilities such as :
\begin{itemize}
	\item Generation and derivation of keys and key-pairs.
	\item Support for several types of cryptographic algorithms.
	\item Pre-allocation of cryptographic operations and key containers so that resources can be allocated ahead of time and reused for multiple operations and with multiple keys over time.
\end{itemize}

\subsubsection*{Time API}
This API provides access to three sources of time :
\begin{itemize}
	\item \textbf{System Time} : The origin of this system time is arbitrary. Different TA instances may even have different system times. The only guarantee is that the system time is not reset or rolled back during the life of a given TA instance, so it can be used to compute time differences and operation deadlines, for example. System time is related to the function \texttt{TEE\_Wait}, which waits for a given timeout or cancellation.
	\item \textbf{TA Persistent Time} : A real-time source of time. The origin of this time is set individually by each Trusted Application and persist across reboots.
	\item \textbf{REE Time} : This is as trusted as the REE itself and may also be tampered by the user.
\end{itemize}

All time functions use a millisecond resolution and split the time in the two fields of the structure \texttt{TEE\_Time}: one field for the seconds and one field for the milliseconds within this second.

\subsubsection*{TEE Arithmetical API}
This API will complement the Cryptographic Operation API, which obviously does not implement all the existing algorithms. The purpose of the TEE Arithmetical API is to provide building blocks so that the developer can implement missing asymmetric algorithms. To ease the design of speed efficient algorithms, the arithmetical API also gives access to a Fast Modular Multiplication primitive, referred to as FMM.

\section{Trusted Firmware-A (TF-A)}
A discussion of the hardware involved in setting up a TEE has been undertaken, as well as an examination of the software that runs between EL0 and EL2. These pieces of software enable communication between the secure and non-secure worlds, as well as providing OS functionality to ensure that the TAs function as they should.

This section will therefore explain the operation of the \textbf{Secure Monitor Firmware} running at EL3 and more globally the \textbf{Trusted Firmware A}.

\subsection{Secure Monitor}
As previously outlined, the role of the \textbf{Secure Monitor (SM)} is to provide a gatekeeper which manages the switches between the secure and non-secure worlds and maintain the security of TrustZone-based systems by controlling access to secure resources, enforcing security policies, and facilitating secure communication between the non-secure word and the secure world. In most designs its functionality is similar to a traditional operating system context switch, ensuring that state of the world that the core is leaving is safely saved, and the state of the world the processor is switching to is correctly restored. The system boots in SM mode and then proceeds to load the Trusted OS (TOS), hypervisor, and the regular operating system.

\subsection{What is the TF-A ?}
Trusted Firmware-A is an open-source project that provides a reference implementation of secure world software for Armv7-A and Armv8-A, including a Secure Monitor executing at Exception Level 3 (EL3).
TF-A also provides the secure bootloader for ARM TrustZone-based systems. TF-A initializes the secure world and provides the foundation for OP-TEE to run trusted applications securely. In other terms, OP-TEE leverages TF-A's secure boot process and runtime services to establish a trusted execution environment for the handling of sensitive operations and data.
\printbibliography
\end{document}

